#ifndef DK_H
#define DK_H

#include <memory>

#include <kbf/driver/button.h>
#include <kbf/driver/lcd.h>
#include <kbf/net.h>
#include <kbf/rtos.h>
#include <kbf/web_service.h>

namespace dk {
    const constexpr char *const TAG = "dk";

    extern std::shared_ptr<kbf::driver::Button> button;

    extern std::shared_ptr<kbf::rtos::EventGroup> mainEventGroup;
    struct MainEvents {
        static const constexpr unsigned int STOP_AP           = 0;
        static const constexpr unsigned int SET_PAIRING_MODE  = 1;
        static const constexpr unsigned int SET_ONLINE_MODE   = 2;
        static const constexpr unsigned int SET_OFFLINE_MODE  = 3;
        static const constexpr unsigned int SEND_TEST_MESSAGE = 4;
    };

    const std::vector<int> ALL_EVENTS = { // NOLINT(cert-err58-cpp)
            MainEvents::STOP_AP,
            MainEvents::SET_PAIRING_MODE,
            MainEvents::SET_ONLINE_MODE,
            MainEvents::SEND_TEST_MESSAGE
    };

    extern std::shared_ptr<kbf::WebService> pairingService;
    extern std::shared_ptr<kbf::WebService> apiService;

    void setPairing(const std::string &pairingId);

    void clearPairing();

    bool paired();

    // old stuff starts here

    void testNotification(); // TODO move to EventManager (?)
}

#endif //DK_H
