#ifndef DOORKEEPER_DEV_SETTINGS_H
#define DOORKEEPER_DEV_SETTINGS_H

#include <string>
#include <map>

#include <kbf/nvs.h>

namespace dk::settings {
    /**
     * @brief (Re)initialise the NVS handle.
     *
     * @warning Must be called after an nvs::erase().
     */
    void init();

    struct Wifi {
        std::string ssid;
        std::string password;
    };

    [[nodiscard]] Wifi wifi();

    void setWifi(Wifi &);

    [[nodiscard]] std::string pairingId();

    void setPairingId(std::string pairingId);

    struct Calibration {
        int high;
        int low;
    };

    [[nodiscard]]  Calibration calibration();

    void setCalibration(Calibration &);
}

#endif //DOORKEEPER_DEV_SETTINGS_H
