#ifndef DOORKEEPER_DEV_ULTRASONIC_H
#define DOORKEEPER_DEV_ULTRASONIC_H

#include <settings.h>

#include <memory>

#include <kbf/task.h>
#include <kbf/rtos.h>

#define READING_INTERVAL_MS CONFIG_DK_ULTRASONIC_READING_INTERVAL
#define CLOSED_CONFIDENCE CONFIG_DK_ULTRASONIC_CLOSED_CONFIDENCE
#define OPEN_CONFIDENCE (-CONFIG_DK_ULTRASONIC_OPEN_CONFIDENCE)

class Ultrasonic : public kbf::Task {
public:
    static constexpr const char *const TAG = "Ultrasonic";

    Ultrasonic(const std::string &name, void *arg, uint32_t stackSize, uint32_t priority) :
            Task(name, arg, stackSize, priority) {}

    static void start();

    static bool enable();

    static void disable();

protected:
    [[noreturn]] void run(void *arg) override;

private:
    static std::shared_ptr<kbf::rtos::EventGroup> eventGroup;
};

#endif //DOORKEEPER_DEV_ULTRASONIC_H
