#include "api/pairing_id_middleware.h"

#include "settings.h"

using std::string;

using namespace kbf;
using http::Request;
using http::Response;

Response PairingIdMiddleware::run(const Request &request, WebService &webService) {
    ESP_LOGD(TAG, "%s()", __func__);

    string expected = dk::settings::pairingId();
    string actual = request.readHeader(HEADER);

    if (actual.empty() || actual != expected) {
        ESP_LOGW(TAG, "expected \"%s\", got \"%s\"", expected.c_str(), actual.c_str());
        return Response("", 403);
    }

    return webService.next(request);
}
