#include "tasks/display_manager.h"

#include <kbf.h>

#include <unity.h>

#define DELAY 3000

using namespace kbf;

TEST_CASE("DisplayManager", "[dm]") {
    DisplayManager::start();

    kbf::sleep(DELAY / 5);
    DisplayManager::setStatus("DM test");
    DisplayManager::setMessage("Starting in 5...");

    kbf::sleep(DELAY);

    DisplayManager::setMessage("default timeout", DisplayManager::defaultTimeout);

    kbf::sleep(DELAY);
    DisplayManager::setStatus("wifi state");

    DisplayManager::setWifiState(DisplayManager::WifiState::AP);
    DisplayManager::setMessage("AP");

    kbf::sleep(DELAY);
    DisplayManager::setWifiState(DisplayManager::WifiState::CONNECTING);
    DisplayManager::setMessage("connecting");

    kbf::sleep(DELAY);
    DisplayManager::setWifiState(DisplayManager::WifiState::ONLINE);
    DisplayManager::setMessage("online");

    kbf::sleep(DELAY);
    DisplayManager::setWifiState(DisplayManager::WifiState::OFFLINE);
    DisplayManager::setMessage("offline");

    kbf::sleep(DELAY);
    DisplayManager::setStatus("door state");

    DisplayManager::setDoorState(DisplayManager::DoorState::CLOSED);
    DisplayManager::setMessage("closed");

    kbf::sleep(DELAY);
    DisplayManager::setDoorState(DisplayManager::DoorState::OPEN);
    DisplayManager::setMessage("open");

    kbf::sleep(DELAY);
    DisplayManager::setDoorState(DisplayManager::DoorState::NOT_CALIBRATED);
    DisplayManager::setMessage("not calibrated");

    kbf::sleep(DELAY);
    DisplayManager::setStatus("DM test");
    DisplayManager::setMessage("finished");
}
